parse source s
say "parse source: ["s"]"
say
-- demonstrate how to access and use the ScriptContext
slotDir=arg(arg()) 	  -- last argument is a directory containing "SCRIPTCONTEXT"
sc=slotDir~scriptContext   -- fetch the ScriptContext object
say "ScriptContext field: ENGINE_SCOPE:" pp(sc~engine_scope)
say "ScriptContext field: GLOBAL_SCOPE:" pp(sc~global_scope)
say
-- import the Java class that defines some Constants like FILENAME, ARGV ...
seClz=bsf.loadClass("javax.script.ScriptEngine")
say "ScriptEngine field: FILENAME="pp(seClz~filename)
say "ScriptEngine field: ARGV    ="pp(seClz~argv)
say
key=seClz~FILENAME	-- get string value for FILENAME entry in Bindings
say "value of ScriptEngine static field named ""FILENAME"":" pp(key)
say "  fetch filename from ScriptContext                :" pp(sc~getAttribute(key))
say "  fetch scope (engine or global) from Scriptcontext:" pp(sc~getAttributesScope(key))
say
key=seClz~ARGV		-- get string value for ARGV entry in Bindings
say "value of ScriptEngine static field named ""ARGV""    :" pp(key)
say "  fetch filename from ScriptContext                :" pp(sc~getAttribute(key))
say "  fetch scope (engine or global) from Scriptcontext:" pp(sc~getAttributesScope(key))

say "---"
say "received" arg() "arguments:"
do i=1 to arg()
   val=arg(i)
   str="    arg("i")=["
   if val~isA(.bsf) then str=str || val~toString"]"
                    else str=str || val"]"
   say str
   if val~isA(.directory) then
   do
      say "    a directory with the following entries:"
      loop idx over val~allIndexes~sort
         say "        idx=["idx"] -> item=["val[idx]"]"
      end
   end
end
