-- 2017-02-09, rgf: this is the ooRexx equivalent of the Java program Test_03.java
manager=.bsf~new("javax.script.ScriptEngineManager")
rse    =manager~getEngineByName("Rexx")

filename="test_rexx_03.rex"   -- define the filename
   -- add the filename to the engine's SimpleBindings
sc=rse~getContext -- get the default ScriptContext
-- sc.setAttribute(ScriptEngine.FILENAME,filename,ScriptContext.ENGINE_SCOPE);
sc~setAttribute(rse~FILENAME,filename,sc~ENGINE_SCOPE)

sc~setAttribute("d1",  "1", sc~GLOBAL_SCOPE)
sc~setAttribute("d2",  "2", sc~GLOBAL_SCOPE)
sc~setAttribute("sum", "3", sc~GLOBAL_SCOPE)
call showAttributes sc
rse~eval(.bsf~new("java.io.FileReader", filename))  -- now let us execute the Rexx script

say; say "... about to call public Rexx routine 'one':"
-- now let us execute a global Rexx routine, forward slotDir argument!
rse~eval("call one arg(arg())")
call showAttributes sc

say; say "... about to call public Rexx routine 'two':"
-- now let us execute a global Rexx routine, forward slotDir argument!
rse~eval("call two arg(arg())")
call showAttributes sc

::requires "BSF.CLS" -- get Java bridge

::routine showAttributes   -- show attributes from ScriptContext
   use arg sc
   say "..." "d1="pp(sc~getAttribute("d1"))", d2="pp(sc~getAttribute("d2")) || -
            "sum="pp(sc~getAttribute("sum")) "..."
